<template>
    <div class="container">
      <div class="col-md-6 mt-5" style="margin:auto; border:2px solid black;" >
        <h2 style="text-align: center;">Update Profile </h2> 
        <div >
          <h4 :class="error ? 'errormessage' : 'defaultErrorMessage' " v.show="error">{{errorMesage}}</h4>
        </div>
        <form @submit.prevent="onUpdateUser()" style="padding:2rem;">
         
          <div class="mb-3 mt-3">
            <label class="form-label">Name:</label>
            <input type="text" class="form-control"  placeholder="Enter Name" @focus="error=false" :defaultValue="user.fullName" @change="handleChangeName">
          </div>
          <div class="mb-3 mt-3">
            <label class="form-label">Email:</label>
            <input type="email" class="form-control" placeholder="Enter email" @focus="error=false" :defaultValue="user.email"
            @change="handleChangeEmail">
          </div>
          
          <div class="mb-3">
          <label class="form-label">Phone:</label>
          <div class="form-group mt-2 d-inline-block">
              <span class="border-end country-code px-2">+91</span>
              <input type="number" class="form-control" autocomplete=off :defaultValue="user.phoneNumber" @focus="error=false" placeholder="Enter Phone Number" @change="handleChangePhone" maxlength=10  />

          </div>
          </div>
          
  
          <div class="mb-3">
            <select class="form-select" :defaultValue="user.country" @change="handleChangeCountry" @focus="error=false">
                <option disabled>Select country</option>
                <option value="India">India</option>
                <option value="Russia">Russia</option>
                <option value="Israel">Israel</option>
            </select>
          </div>
  
          <div class='col-md-12 mb-3 row' style="padding-left:10px;">
            <div class="form-check  col-md-2" v-for="(element,index) in arr" :key="index" >
                <input class="form-check-input" type="radio"  :value="element" :checked="element === user.gender" name="group1" @change="handleChangeGender" @focus="error=false">
                <label class="form-check-label">
                  {{ element }}
                </label>
            </div>
          </div>
  
          <div class="form-check mb-3">
            <label class="form-check-label" for="flexCheckChecked">
              Open to remote work?
            </label>
            <input class="form-check-input" type="checkbox" v-model="user.remote_work" true-value="yes" false-value="no" @change="handleChangeRemoteWork" >
          </div>
          <div style="text-align:center">
            <button type="submit" class="btn btn-primary" >Update</button>
          </div>
        </form> 
      </div>
    </div>
  </template>
  <script>
  import {mapState,mapActions} from 'vuex';
  import {updateFormValidations} from '../services/Validations';
  import { UPDATE_USER,FETCH_USER } from '../store/storeConstants';
  export default{
      name: "SignupPage",
      data() {
          return {
              error:false,
              errorMesage:"",
              updatedObj:{
              },
              arr:['Male','Female','Other'],
              countryArr:['India', 'Russia', 'Israel']
          };
      },
      methods: {
        ...mapActions("auth", {
          updateUser: UPDATE_USER
        }),

        async onUpdateUser() {  
          let validation = await updateFormValidations(this.updatedObj);
          if(validation.success){
            let phone = this.updatedObj.phoneNumber
            this.updatedObj.phoneNumber = parseInt(phone)
            this.updateUser({"updateObj":this.updatedObj,"token":window.localStorage.getItem('token')}).catch(err=>{
              this.error = true
              this.errorMesage = err
            })
          }else{
            this.error = true
            this.errorMesage = validation.message
            }
        },
        handleChangeName(event){
          this.updatedObj.fullName = event.target.value 
        },
        handleChangeEmail(event){
          this.updatedObj.email = event.target.value 
        },
        handleChangePhone(event){
          this.updatedObj.phoneNumber = event.target.value.replace(" ",'')
        },
        handleChangeCountry(event){
          this.updatedObj.country = event.target.value.replace(" ",'')
        },
        handleChangeRemoteWork(event){
          if(event.target.checked){
            this.updatedObj.remote_work = "yes"
          }else{
            this.updatedObj.remote_work = "no"
          }
        },
        handleChangeGender(event){
          this.updatedObj.gender = event.target.value.replace(" ",'')
        }
      },

      computed: {
        ...mapState("auth", {
              user: state => state.users
          }),
          getName() {
              return this.$store.state.auth.name;
          }, 
          getPhone(){
            return this.user.phoneNumber
          },
       
          
      },
      mounted() {
        this.$store.dispatch(`auth/${FETCH_USER}`,{"token":window.localStorage.getItem('token')})
      },
  
      
  }
  
  </script>
  
  
  <style>
  .errormessage{
    font-size: 28px;
    color: red;
    margin: auto;
    text-align: center;
  }
  .defaultErrorMessage{
    visibility: hidden;
  }
  .form-group {
  border: 1px solid #ced4da;
  padding: 5px;
  border-radius: 6px;
  width: 100%;
}
.form-group:focus {
  color: #212529;
    background-color: #fff;
    border-color: #86b7fe;
    outline: 0;
    box-shadow: 0 0 0 0.25rem rgb(13 110 253 / 25%);
}
.form-group input {
  display: inline-block;
  width: auto;
  border: none;
}
.form-group input:focus {
  box-shadow: none;
}
input::-webkit-outer-spin-button,
input::-webkit-inner-spin-button {
  -webkit-appearance: none;
  margin: 0;
}
  </style>
  